--[[
 =head1 NAME
 
 applets.MyHome.MyHomeApplet - MyHome Applet
 
 =head1 DESCRIPTION
 
 Enables the SqueezePlay to control Innovus Home Automation system
 
 =head1 FUNCTIONS
 
 
 
 =cut
 --]]
 
 
 
 local tostring 			= tostring
 local tonumber 			= tonumber
 local assert 				= assert
 local oo					= require("loop.simple")
 local string				= require("string")
 local pairs 				= pairs
 local ipairs 				= ipairs
 local table 				= table
 local jnt					= jnt
 local Applet				= require("jive.Applet")
 local RadioButton			= require("jive.ui.RadioButton")
 local RadioGroup			= require("jive.ui.RadioGroup")
 local Window				= require("jive.ui.Window")
 local Popup				= require("jive.ui.Popup")
 local Textarea				= require('jive.ui.Textarea')
 local Icon					= require("jive.ui.Icon")
 local SimpleMenu			= require("jive.ui.SimpleMenu")
 local Timer				= require("jive.ui.Timer")
 local RadioGroup			= require("jive.ui.RadioGroup")
 local Checkbox				= require("jive.ui.Checkbox")
 local Slider				= require("jive.ui.Slider")
 local Choice				= require("jive.ui.Choice")
 local Socket				= require("jive.net.SocketTcp")
-- local UdpBroadcast			= require("jive.net.SocketUdpBcast")
 local log					= require("jive.utils.log").addCategory("MyHome", jive.utils.log.DEBUG)
 local tcpsock				= require("socket.core")
 
 local Textinput			= require("jive.ui.Textinput")
 local Label				= require("jive.ui.Label")
 local lxp					= require("lxp")


local EVENT_KEY_PRESS		= jive.ui.EVENT_KEY_PRESS
local KEY_GO				= jive.ui.KEY_GO
local KEY_PLAY				= jive.ui.KEY_PLAY
local KEY_ADD				= jive.ui.KEY_ADD
local EVENT_HIDE			= jive.ui.EVENT_HIDE
local EVENT_SHOW			= jive.ui.EVENT_SHOW


 module(...)
 oo.class(_M, Applet)
 
 
function settingsmenu(self)
	log:info("settings menu")
	local showRooms = self:getSettings().showRooms
	local showProtected = self:getSettings().showProtected
	local showAllOff = self:getSettings().showAllOff
	--local v = Textinput.ipAddressValue("0.0.0.0")
	local currentSetting = self:getSettings().currentSetting
	local group = RadioGroup()
	local reset = 2
	local window = Window("windowset", self:string("SETTINGS_MENU")) 
	if self:getSettings().resetOnStartup then reset = 1 end
	local menu = SimpleMenu("menu", {
		
		{
			text = self:string("DISPLAY_ROOMS"),
			icon = Choice(
				"choice",
				{self:string("YES"),self:string("NO")},
				function(self1, selectedIndex)
					log:info("New Showrooms setting " .. selectedIndex)
					--settings={}
					self:getSettings()['showRooms'] = selectedIndex
					self:storeSettings()
					
				end,
				showRooms)
		},
		{
			text = self:string("SHOW_PROTECTED_DEVICES"),
			icon = Choice(
				"choice",
				{self:string("YES"), self:string("NO")},
				function(self1, selectedIndex)
					log:info("New Show protected setting " .. selectedIndex)
					--settings={}
					self:getSettings()['showProtected'] = selectedIndex
					self:storeSettings()
				
				end,
				showProtected)
		},
		{
			text = self:string("SHOW_ALL_OFF"),
			icon = Choice(
				"choice",
				{self:string("YES"), self:string("NO")},
				function(self1, selectedIndex)
					log:info("New Show ALL OFF setting " .. selectedIndex)
					--settings={}
					self:getSettings()['showAllOff'] = selectedIndex
					self:storeSettings()
				
				end,
				showAllOff)
		
		},
		{
			text = self:string("SCENES_SETTINGS"),
			callback = function(event, menuItem)
					scenesSettingsMenu(self)
					end
		},
		{
			text = self:string("TIMER_SETTINGS"),
			callback = function(event, menuItem)
							timerSettings(self)
						end
		},
		{
			text = self:string("SYNC_WITH_IHC"),
			callback = function(event, menuItem)
					syncWithIHC(self, self:getSettings().ihcIP)
				   end
		},
		{
			text = self:string("IHCIP"),
			sound = "WINDOWSHOW",
			callback = function(event, menuItem)
					log:info("Call get ip menu")
					self:ipinputWindow()
					log:info("Back from input")
					--window:playSound("WINDOWSHOW")
					--window:hide(Window.transitionPushLeft)
					
				end
		},
		{
			text = self:string("RESET_SETTINGS"),
			icon = Choice("choice",
					{self:string("YES"), self:string("NO")},
					function (self1, selectedIndex)
						log:info("Selected index= ", selectedIndex)
						if ( selectedIndex == 1) then
							log:info("Setting reset flag and starting timer")
							window:addWidget(Textarea("softHelp", self:string("CONFIRM_RESET_SETTINGS")))
							window:addWidget(Label("softButton1", self:string("YES")))
							window:addWidget(Label("softButton2", self:string("NO")))
							window:addListener(EVENT_KEY_PRESS,	function(evt, menuItem)
													if (evt:getKeycode() == KEY_ADD) then
														log:info("Reset confirmed")
														self:getSettings().ihcIP = "0.0.0.0"
														self:getSettings().showRooms = 1
														self:getSettings().zwDevices = {}
														self:getSettings().showProtected = 1
														self:getSettings().showAllOff = 1
														self:getSettings().zwSceneNames = {"[Empty]", "[Empty]", "[Empty]", "[Empty]", "[Empty]", "[Empty]", "[Empty]", "[Empty]", "[Empty]"}
														self:getSettings().zwScenes = {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}
														self:getSettings().wol = {"000000000000","000000000000","000000000000","000000000000","000000000000","000000000000","000000000000","000000000000","000000000000","000000000000"}
														self:storeSettings()
														window:hide(Window.transitionPushLefts)
													elseif (evt:getKeycode() == KEY_PLAY) then
														log:info("Reset cancled")
														window:hide(Window.transitionPushLefts)
													end
												end)
						end
					end,
					2)
		},
		
				
	})

	window:addWidget(menu)
	window:show()
	
end

function ipinputWindow(self)
	local window = Window("window", self:string("IPADDRESS_INPUT_WINDOW_CAPTION"))
	local ihcIP = self:getSettings().ihcIP
	
	local v = Textinput.ipAddressValue(ihcIP)
	
	local input = Textinput("textinput", v,
				function(self1, value)
					log:info("Input " .. value:getValue())
					local newip = value:getValue()
					self:getSettings()['ihcIP'] = newip
					self:getSettings()['zwDevices'] = {}
					self:storeSettings()
					--window:playSound("WINDOWSHOW")
					window:hide(Window.transitionPushLeft)
					return true
				end)

	local help = Textarea("help", self:string("IPADDRESS_INPUT_HELP"))

	window:addWidget(help)
	window:addWidget(input)

	self:tieAndShowWindow(window)
	return window
end
 


function hexinputWindow(self, sceneid)
	local window = Window("window", self:string("ENTER_MAC_ADDRESS"))
	local mac = self:getSettings().wol[sceneid]
	local v = Textinput.hexValue(mac)
	local input = Textinput("textinput", v,
				function(_, value)
					log:info("WOL MAC: " .. value:getValue())
					self:getSettings().wol[sceneid] = value:getValue()
					self:storeSettings()
					window:playSound("WINDOWSHOW")
					window:hide(Window.transitionPushLeft)
					return true
				end)

	local help = Textarea("help", self:string("WOL_HELP"))

	window:addWidget(help)
	window:addWidget(input)

	self:tieAndShowWindow(window)
	return window
end




function editSceneMenu(self, sceneid)
	log:info("Edit scene menu id= ", sceneid)
	local windowcaption = self:string("EDIT_SCENE")
	local window = Window("window", windowcaption)
	local menu = SimpleMenu("menu",
				{
				{
				text = self:string("CHANGE_SCENE_NAME"), 
				callback = function(event, menuItem)
						log:info("Selected change scene name 1")
						changeSceneName(self, sceneid)
					end
				},
				{
				text = self:string("CHOOSE_SCENE_DEVICES"),
				callback = function(event, menuItem)
						log:info("Choose deices for scene")
						addDevicesToScene(self, sceneid)
					end
				},
				{
				text = self:string("ADD_WOL_ADDRESS"),
				callback = function(event, menuItem)
							hexinputWindow(self, sceneid)
						end
				},
				{
				text = self:string("DELETE_SCENE"),
				icon = Choice("choice",
						{" ",  " "},
						function(selectedIndex)
							self:getSettings().zwSceneNames[sceneid] = "[Empty]"
							self:getSettings().zwScenes[sceneid] = {}
							self:getSettings().wol[sceneid] = "000000000000"
							self:storeSettings()
							window:hide(Window.transitionPushRight)
						end,
						1)
				},
				}
				)
	window:addWidget(menu)
	window:show()
end 
 
 
function changeSceneName(self, sceneid)
	log:info("Function gettext 2")
	local window = Window("window", self:string("ENTER_SCENE_NANE"))
	local ct = self:getSettings().zwSceneNames[sceneid]
	if (ct == "[Empty]") then ct = "" end
	local v = Textinput.textValue(ct, 1, 30)
	local name = Textinput("textinput",v,
				function(self1, value)
					self:getSettings().zwSceneNames[sceneid] = value.s
					self:storeSettings()
					log:info("Text input done 3")
					window:hide(Window.transitionPushRight)
				end
			)
	window:addWidget(name)
	self:tieAndShowWindow(window)
	log:info("Done with function textinput 4")
end


function isInScene(scene, node)
	local ret = false
	for k, v in pairs(scene) do
		if (node == k) then ret = true end
	end
	return ret
end

 
 function addDevicesToScene(self, sceneid)
 	local window = Window("window", self:string("SELECT_SCENE_DEVICES_MENU"))
 	local menuitems = {}
 	local zwdevices = self:getSettings().zwDevices.names
 	local zwtypes = self:getSettings().zwDevices.types
 	local onescene = self:getSettings().zwScenes[sceneid]
 	
 	for k,v in pairs(zwdevices) do
 		log:info("Listing device: ", v)
 		local lable = ""
 		if (isInScene(onescene, k)) then
 			if ((zwtypes[k] == "binary_switch") and (onescene[k] == 1)) then
 				lable = string.format("%s (%s)", v, tostring(self:string("ON")))
 			elseif ((zwtypes[k] == "binary_switch") and (onescene[k] == 2)) then
 				lable = string.format("%s (%s)", v, tostring(self:string("OFF")))
 			elseif ((zwtypes[k] == "multilevel_switch") and (onescene[k] > 1)) then
 				lable = string.format("%s (%s%%)", v, tostring(onescene[k]))
 			else
 				lable = string.format("%s (%s)", v, tostring(self:string("OFF")))
 			end
 		else
 			lable = v
 		end
 				
 		local oneitem =	{text = lable, icon = Checkbox("checkbox",
 							function(self1, isSelected)
 								if isSelected then
 									local zwtype = zwtypes[k]
 									local state = getState(self, k, zwtype)
 									if (zwtype == "binary_switch") then
 										onescene[k] = state.onoff
 									else
 										if (state.onoff == 1) then
 											onescene[k] = state.level
 										else
 											onescene[k] = 0
 										end
 									end
 								else
 									onescene[k] = nil
 									--table.remove(onescene, tostring(k))
 								end
 								self:getSettings().zwScenes[sceneid] = onescene
 								self:storeSettings()
 							end,
 							isInScene(onescene, k)
 							)
 				}
 		table.insert(menuitems, oneitem)
 	
 	end --for
	local menu = SimpleMenu("menu", menuitems)
	window:addWidget(menu)
	window:show()
 end
 
 
 
function scenesSettingsMenu(self)
	log:info("Scenes menu")
	
	local window = Window("window", self:string("SCENES_MENU"))
	local menu = SimpleMenu("menu", {})
	window:addListener(EVENT_HIDE, function(evt, menuItem)
										window:removeWidget(menu)
									end)
	
	window:addListener(EVENT_SHOW, function(evt, menuItem)
										local menuitems = {}
										local zwscenenames = self:getSettings().zwSceneNames
	
										for k,v in ipairs(zwscenenames) do
											local label = string.format("%d %s", k, v)
		
											local oneitem = {text = label, callback = function(event, menuItem)
																						log:info("Changing sceen id= " .. k)
																						editSceneMenu(self, tonumber(k))
													
																						end
															}
											table.insert(menuitems, oneitem)
										end
										menu = SimpleMenu("menu",menuitems)
 										window:addWidget(menu)
 									end) --event function
	window:show()
	
end

function toHex(str)
	local ret = ""
	local byteval = tonumber(str,16)
	if (byteval != 0) then
		ret = string.format("%c", byteval)
	else
		ret = "\0"
	end
	log:info("toHex returning ", ret , " as a result of ", str)
	return ret
end


function sendWOL(self, macaddr)
	log:info("Sending Magicpacket to ", macaddr)
	local mp = string.format("%c%c%c%c%c%c", 255, 255, 255, 255, 255, 255)
	local binmac = ""
	for mc=1, 12, 2 do
		binmac = binmac .. toHex(macaddr:sub(mc, mc+1))
	end
	mp = mp .. string.rep(binmac, 16)
	local wol = tcpsock.udp()
	--log:info("MP was ", mp)
	wol:setoption("broadcast", true)
	local res, err = wol:sendto(mp, "255.255.255.255", 9)
	--log:info("UDP send result ", res, " Status was ", err)
end


function scenesMenu(self)
	log:info("Scenes menu")
	
	local window = Window("window", self:string("SCENES_MENU"))
	local help = Textarea("help", self:string("NO_SCENES_HELP"))
	
	local zwscenenames = self:getSettings().zwSceneNames
	local zwtypes = self:getSettings().zwDevices.types
	local hasScenesConfiguret = false
	local menuitems = {}
	for k,v in ipairs(zwscenenames) do
		local label = k .. " " .. v
		log:info("Adding Scene name: ", v)
		if (v != "[Empty]") then
			hasScenesConfiguret = true
			local oneitem = {text = label, icon = Choice("choice", 
									{" ", " "}, 
									function(selectedIndex)
										log:info("Activating sceene id= " .. k)
										local onescene = self:getSettings().zwScenes[k]
										local xml = "<root>"
										for lk, lv in pairs(onescene) do
											if (zwtypes[lk] == "binary_switch") and (lv == 1) then
												xml = xml .. "<set xmlns=\"urn:zw\"><node id=\"" .. lk .. "\"><binary_switch><on/></binary_switch></node></set>"
											elseif (zwtypes[lk] == "binary_switch") and (lv == 2) then
												xml = xml .. "<set xmlns=\"urn:zw\"><node id=\"" .. lk .. "\"><binary_switch><off/></binary_switch></node></set>"
											elseif (zwtypes[lk] == "multilevel_switch") then
												xml = xml .. "<set xmlns=\"urn:zw\"><node id=\"" .. lk .. "\"><multilevel_switch><level>" .. lv .. "</level></multilevel_switch></node></set>"
											end
												
										end
										xml = xml .. "</root>\0"
										-- send XML here
										local xmls = tcpsock.tcp()
										local ihcIP = self:getSettings().ihcIP
										xmls:settimeout(5,'t')
										assert(xmls:connect(ihcIP,8081), "Unable to connect to IHC @ " .. ihcIP)
										xmls:send(xml)
										xmls:close()
										log:info("Sender scene XML: ", xml)
										local woladdr = self:getSettings().wol[k]
										if (woladdr != "000000000000") then
											
											sendWOL(self, woladdr)
										end
										window:hide(Window.transitionPushRight)
									end,
									1)
					}
				
			table.insert(menuitems, oneitem)
		end --if
	end --for
	if (hasScenesConfiguret) then
		local menu = SimpleMenu("menu",menuitems)
 		window:addWidget(menu)
 	
 	else
 		--Textarea("help", self:string("NO_SCENES_HELP"))
 		window:addWidget(help)
 	
 	end
 	
	window:show()
	
end







 -- Main program section
 function menu(self, menuItem)
 
	log:info("menu")
	local ihcIP = self:getSettings().ihcIP
	local zwnames = self:getSettings().zwDevices.names

	if (ihcIP == "0.0.0.0") then
		self:ipinputWindow()
		return
	end

	if (zwnames == nil) and (ihcIP != "0.0.0.0") then
		log:info("Auto syncing with IHC")
		self:syncWithIHC(ihcIP)
	end
        
	local showrooms = self:getSettings().showRooms
	local zwrooms = self:getSettings().zwDevices.rooms
	local showalloff = self:getSettings().showAllOff
	local allidb = ""
	local allidm = ""
	local menuitems = {}
	local window = Window("window", self:string("MYHOME"))
	--local xml = tcpsock.tcp()
	
	local oneitem = {text = self:string("SCENES_MENU"), callback = function(event, menuItem)
																		log:info("Selected scenes menu from main menu")
																		scenesMenu(self)
																end
					}
	table.insert(menuitems, oneitem)
	
	if (showrooms == 1) then
		for k,v in pairs(zwrooms) do
			local oneitem = {text = k, callback=function(event, menuItem)	
													local windowroom = Window("window", k)
													local menuitems = getDeviceMenuItems(self,k)
													local oneicon = Choice ("choice",
																			{" ", " "},
																			function (self1, selectedItem)
																				allOff(self, k)
																				windowroom:hide(Window.transitionPushRight)
																			end,
																			2)
		
													local oneitem =	{text = self:string("ALL_OFF"), icon = oneicon}
													if (showalloff == 1) then table.insert(menuitems, oneitem) end
													local menurooms = SimpleMenu("menu",menuitems)
													windowroom:addWidget(menurooms)
																			
													-- show the window
													windowroom:show()
												end
							}
			table.insert(menuitems, oneitem)
		end
	else
		menuitems = getDeviceMenuItems(self, "ALL")
	end --if

	local oneicon = Choice ("choice",
			{" ", " "},
			function (self1, selectedItem)
				allOff(self, "ALL")
				window:hide(Window.transitionPushRight)
			end,
			2)
		
	local oneitem =	{text = self:string("ALL_OFF"), icon = oneicon}
	if (showalloff == 1) then table.insert(menuitems, oneitem) end
       -- create a SimpleMenu object with selections to be created       
       local menu = SimpleMenu("menu",menuitems)
 
       -- add the SimpleMenu to the window
       window:addWidget(menu)
		
       -- show the window
       window:show()
 end
 
function isDeviceInRoom(self, room, id)
	local zwrooms = self:getSettings().zwDevices.rooms
	local ret = false
	local roomids = zwrooms[room]
	for k,v in ipairs(roomids) do
		if v == tonumber(id) then ret=true end
	end
	return ret

end
 
 function allOff(self, room)
 	local allidsb = ""
	local allidsm = ""
	local xml = tcpsock.tcp()
	local ihcIP = self:getSettings().ihcIP
	local zwnames = self:getSettings().zwDevices.names
	local zwtypes = self:getSettings().zwDevices.types
	local zwprotected = self:getSettings().zwDevices.protected
	
	
	for k,v in pairs(zwnames) do
		if ((zwprotected[k] == "no") or (self:getSettings().showProtected == 1)) and ((room == "ALL") or (isDeviceInRoom(self, room, k))) then
			if (string.len(allidsb) > 0) and (zwtypes[k] == "binary_switch") then
				allidsb = allidsb .. "," ..tostring(k)
			elseif (zwtypes[k] == "binary_switch") then
				allidsb = tostring(k) 
			end
			if (string.len(allidsm) > 0) and (zwtypes[k] == "multilevel_switch") then
				allidsm = allidsm .. "," ..tostring(k)
			elseif (zwtypes[k] == "multilevel_switch") then
				allidsm = tostring(k)
			end
		end --if
		
	end-- for
	xml:settimeout(5,'t')
	assert(xml:connect(ihcIP,8081), "Unable to connect to IHC @ " .. ihcIP)
	xml:send("<root><set xmlns=\"urn:zw\"><node id=\"".. allidsb .."\"><binary_switch><off/></binary_switch></node></set></root>\0")
	xml:send("<root><set xmlns=\"urn:zw\"><node id=\"".. allidsm .."\"><multilevel_switch><off/></multilevel_switch></node></set></root>\0")
	xml:close()
 end
 
 
 
function getDeviceMenuItems(self, room)
	local xml = tcpsock.tcp()
	local menuitems = {}
	local ihcIP = self:getSettings().ihcIP
	local zwnames = self:getSettings().zwDevices.names
	local zwtypes = self:getSettings().zwDevices.types
	local zwprotected = self:getSettings().zwDevices.protected
	--local zwrooms = self:getSettings().zwDevices.rooms
	
	local inhandler = false
	
	table.sort(zwnames)
	
	for k,v in pairs(zwnames) do
		if ((zwprotected[k] == "no") or (self:getSettings().showProtected == 1)) and ((room == "ALL") or (isDeviceInRoom(self, room, k))) then
			local state = getState(self, k, zwtypes[k])
			local oneicon = {}
			oneicon = Choice("choice", 
							{self:string("ON"), self:string("OFF")},
							function(self, selectedIndex) 
								log:info("Selected " .. tostring(selectedIndex))
								local xml = tcpsock.tcp()
								xml:connect(ihcIP,8081)
								if selectedIndex == 1 then
									xml:send("<root><set xmlns=\"urn:zw\"><node id=\"".. k .."\"><".. zwtypes[k] .."><on/></" .. zwtypes[k] .. "></node></set></root>\0")
								else
									xml:send("<root><set xmlns=\"urn:zw\"><node id=\"".. k .."\"><".. zwtypes[k] .."><off/></" .. zwtypes[k] .. "></node></set></root>\0")
								end
								xml:close()
								local oneicon = {}
							end, 
							state.onoff
						)
			if zwtypes[k] == "multilevel_switch" then
			log:info("Adding listeer......")
			oneicon:addListener(EVENT_KEY_PRESS,	function(evt, menuItem)
													log:info("Event key= ", evt:getKeycode(), " On menuitem= ", menuItem)
													if (evt:getKeycode() == KEY_ADD) and (not inhandler) then
														log:info("GOGO KEY EVENT!")
														inhandler= true;
														local windowdim = Window("window", v)
														local label = Textarea("label", "Sæt lysniveau HEST")
														local newvalue = 0
														local state = getState(self, k, zwtypes[k])
														if (state.onoff == 2) then state.level = 0 end
														local ihcIP = self:getSettings().ihcIP
														local timer = Timer(200, function()
																					log:info("slider value= ", newvalue)
																					local xml = tcpsock.tcp()
																					local req = "<root><set xmlns=\"urn:zw\"><node id=\"" .. k .. "\"><multilevel_switch><level>" .. newvalue .. "</level></multilevel_switch></node></set></root>\0"
																					xml:settimeout(2,"t")
																					assert(xml:connect(ihcIP,8081), "Unable to connect to IHC @ " .. ihcIP)
																					xml:send(req)
																					xml:close()
																					if (newvalue > 0) then 
																						oneicon:setSelectedIndex(1)
																					else
																						oneicon:setSelectedIndex(2)
																					end
																				end,
																				true
																			)
														local slider = Slider("slider",0,33,state.level/3, function (slider, value, done)
																												if (done) then
																													inhandler=false;
																													windowdim:hide(Window.transitionPushRight)
																												else
																													newvalue = value*3
																													timer:restart()
																												end
																											end
       							
																				)
       							
														--windowdim:addWidget(label)
														windowdim:addWidget(slider)
														windowdim:show()
													end -- if
												end -- function
								)
							
			end			
			--log:info("Icon string = " .. oneicon)		
			local oneitem = {text = v, icon = oneicon}
			table.insert(menuitems, oneitem)
		end -- if
	end --for
	
	return menuitems

end


function getState(self, id, zwtype)
	
	local ret = {onoff=2, level=0} -- onoff 1=on 2=off
	local ihcIP = self:getSettings().ihcIP
	log:info("Getting state for id= " .. id .. " From IHC @ " .. ihcIP)
	local xmlreq = "<root><get xmlns=\"urn:zw\" seqnr=\"87263\"><node id=\"" .. id .. "\"><" .. zwtype .. "/></node></get></root>\0"
	local xml = tcpsock.tcp()
	xml:settimeout(10,'t')
	assert(xml:connect(ihcIP,8081), "Unable to connect to IHC @ " .. ihcIP)
	log:info("Connected. Sending XML: " .. xmlreq)
	xml:send(xmlreq)
	local xmldata = ""
	local oneline = " "
	repeat 
		local oneline = xml:receive(1)
		if oneline != "\0" then
			--log:info("Got char: " .. oneline)
			if(oneline != nil) then xmldata = xmldata .. oneline end
		end
	until oneline == "\0"
	xml:close()
	
	log:info("Got XML state data: " .. xmldata)
	local gotblock = false
	callbacks = {
		StartElement = function (parser, name, attributes)
				--log:info("In parser callback StartElement")
				if (name=="report") and (attributes.seqnr=="87263") then
					log:info("Found tag with the right seqnr")
					gotblock = true	
				elseif (gotblock) and (name== "on") then
					log:info("Returning id= " .. id .. " as ON")
					ret.onoff = 1
				elseif (gotblock) and (name == "off") then
					log:info("Returning id= " .. id .. " as OFF")
					ret.onoff = 2
				elseif (gotblock) and (name == "level") then
					callbacks.CharacterData = function(parser, string)
									log:info("Level =", string)
									ret.level = tonumber(string)
									
								  end
				end
			end,
		EndElement = function (parser, name)
				--log:info("In parser callback EndElement")
				if (name == "report") then
					gotblock = false
				elseif (name == "level") then
					callbacks.CharacterData = false
				end
			end,
		CharacterData = false
				
		}
		
	local p = lxp.new(callbacks)
	log:info("Start parsing")
	p:parse(xmldata)
	p:parse()
	p:close()
		
	return ret
end


function syncWithIHC1(self, ip)
	local popup = Popup("popupIcon")

	--FIXME, this window does not layout correctly (Bug 5412)
	local icon = Icon("iconConnecting")
	local text = Label("text", "Syncronzing with\nInnovus House Controller")
	local label = Label("downloading", "0%")

	popup:addWidget(label)
	popup:addWidget(icon)
	popup:addWidget(text)
	
	popup:setAlwaysOnTop(true)
        popup:setAutoHide(false)
        
	self:tieAndShowWindow(popup)
	syncWithIHC1(self, ip)
end



function syncWithIHC(self, ip)
	log:info("Start IHC sync.... IP " .. ip)
	
	local zwnames = {}
	local zwtypes = {}
	local zwprotected = {}
	local zwrooms = {}
	
	local protectionblock = false
	local currentid = 0
	local currentroom = "**none"
	
	local callbacks = {
		StartElement = function (parser, name, attributes)
			if (name=="node") and (currentroom != "**none") and ((attributes.type=="multilevel_switch") or (attributes.type=="binary_switch")) then
				log:info("Found node " .. attributes.name .. ", ID= " .. attributes.id .. ", Type= " .. attributes.type)
				
				zwnames[attributes.id] = attributes.name
				zwtypes[attributes.id] = attributes.type
				zwprotected[attributes.id] = "no"
				currentid = attributes.id
				table.insert(zwrooms[currentroom], tonumber(attributes.id))
			elseif (name == "protection") then
				protectionblock = true
			elseif  (name == "disabled") and (protectionblock) and (currentid != 0) then 	
				zwprotected[currentid] = "yes"
			elseif (name == "room") and (attributes.type != "0") then
				currentroom = attributes.name
				zwrooms[currentroom] = {}
			end
		end,
		EndElement = function (parser, name)
			if (name == "protection") then
				protectionblock = false
			elseif (name == "rooms") then
				currentroom = "**none"
			end
		end
			
	}

	local p = lxp.new(callbacks)
	local xml = tcpsock.tcp()
	xml:settimeout(3,'t')
	assert(xml:connect(ip,8081), "Unable to connect to IHC @ " .. ip)
	log:info("Connected to ", ip)
	xml:send("<root><mhx f=\"get\"><rooms/></mhx></root>\0")
	log:info("Get rooms send")
	
	local xmldata = ""
	
	repeat 
		local oneline, err = xml:receive(15)
		--log:info("Got char: ",  oneline, " Status= ",err)
		if (oneline != nil) then
			p:parse(oneline)
		end
		
	until (oneline == nil)
	xml:close()
	
	p:parse()
	p:close()
	log:info("Done parsing XML")
	local zwdevices = {names=zwnames, types=zwtypes, protected=zwprotected, rooms=zwrooms}
	self:getSettings().zwDevices = zwdevices
	self:storeSettings()
	log:info("Done with IHC sync")
end
 
 
-- ================================================
-- ==          Timer implementation below        ==
-- ================================================
function deleteTimerTask(self, id, ip)
	local xml = tcpsock.tcp()
	xml:settimeout(1)
	xml:connect(ip, 8081)
	xml:send("<root><mhx f=\"delete\"><task id=\"" .. tostring(id) .. "\"/></mhx></root>\0")
	repeat
		r = xml:receive(10)
	until r == nil
	xml:close()
end


function sendTaskToIHC(self, task, ip)
	local zwtypes = self:getSettings().zwDevices.types
	
	local xml = tcpsock.tcp()
	xml:settimeout(1)
	xml:connect(ip, 8081)	
	log:info("TASK ID= ", task.taskid)
	if (tonumber(task.taskid) != 0) then
		log:info("Task will be UPDATED")
		xml:send("<root><mhx f=\"update\"><task id=\"" .. tostring(task.taskid) .. "\"><start>2000-01-02 11:12:00</start><rrule>")	
	else
		log:info("Task will be CREATED")
		xml:send("<root><mhx f=\"create\"><task><start>2000-01-02 11:12:00</start><rrule>")
	end
	xml:send("<byhour>" .. task.hour .. "</byhour><byminute>" .. task.minute .. "</byminute>")
	local weekdays = ""
	for dc=1, 7 do
		if (task.days[dc]) then
			weekdays = weekdays .. tostring(dc) .. " "
		end
	end
	if (weekdays:len() > 1) then weekdays = weekdays:sub(1, weekdays:len() -1) end
	xml:send("<byweekday>" .. weekdays .. "</byweekday>")
	if (not task.enabled) then
		log:info("Task is disabled")
		xml:send("<until>2000-01-02 11:13:00</until>")
	end
	
	xml:send("</rrule><macro><set xmlns=\"urn:zw\">")
	for k, v in pairs(task.devices) do
		log:info("ToXML: Node = ", k, " State = ", v)
		if (zwtypes[k] == "binary_switch") then
			xml:send("<node id=\"" .. tostring(k) .. "\"><binary_switch>")
			if (v == 1) then
				xml:send("<on/>")
			else
				xml:send("<off/>")
			end
			xml:send("</binary_switch></node>")
		else
			xml:send("<node id=\"" .. tostring(k) .. "\"><multilevel_switch><level>" .. tostring(v) .. "</level></multilevel_switch></node>")
		end
	end
	xml:send("</set></macro></task></mhx></root>\0")
	repeat
		r = xml:receive(10)
	until r == nil	

	xml:close()

end


function getTasksFromIHC(self, ip)
	local xml = tcpsock.tcp()
	local zwtypes = self:getSettings().zwDevices.types
	local xmlreq = "<root><mhx f=\"get\"><tasks/></mhx></root>\0"
	--local currenttaskno = 0
	local issqueezetask = false
	local alltasks = {}
	local squeezetag = ""
	local enebledtag = ""
	local currentnode = 0
	local onenode = {id = 0, state = ""}
	local onetask = {taskid = 0, hour = "", minute = "", devices  = {}, enabled = true, days = {false, false, false, false, false, false, false}}
	
	
	saxcallbacks = {
						StartElement = function (parser, name, attributes)
											if (name == "task") then
												--currenttaskno = currenttaskno + 1
												--issqueezetask = true
												onetask.taskid = attributes.id
											
											elseif (name == "byhour") then
												saxcallbacks.CharacterData = function(parser, str)
																				onetask.hour = onetask.hour .. str
																			end
											elseif (name == "byminute") then
												saxcallbacks.CharacterData = function(parser, str)
																				onetask.minute = onetask.minute .. str
																			end
											elseif (name == "byweekday") then
												saxcallbacks.CharacterData = function(parser, str)
																				local cdata = str:gsub("^%s*", "")
																				log:info("weekday len=", cdata:len())
																				for c = 1, cdata:len(), 2 do
																					log:info("c=", c, " Parsed number=", cdata:sub(c, c), " string=", cdata)
																					onetask.days[tonumber(cdata:sub(c, c))] = true
																				end
																			end
											elseif (name == "start") then
												saxcallbacks.CharacterData = function(parser, str)
																				--log:info("Start day: ", str)
																				squeezetag = squeezetag .. str
																				if (squeezetag == "2000-01-02 11:12:00") then 
																					issqueezetask = true
																					log:info("Found Squeeze task!")
																				end
																			end
											elseif (name == "until") then
												saxcallbacks.CharacterData = function(parser, str)
																				enabledtag = enabledtag .. str
																				if (enabledtag == "2000-01-02 11:13:00") then
																					onetask.enabled = false
																				end
																			end
											elseif (name == "node") then
												currentnode = attributes.id
												onenode.id = tonumber(attributes.id)
											elseif ((name == "on") and (currentnode != 0)) then
												onenode.state = 1
											elseif ((name == "off") and (currentnode != 0)) then
												if(zwtypes[currentnode] == "binary_switch") then
													onenode.state = 2
												else
													onenode.state = 0
												end
											elseif ((name == "level") and (currentnode != 0)) then
												saxcallbacks.CharacterData = function(parser, str)
																				--onenode["12"] = 12
																				log:info("Adding to level string ", str)
																				onenode.state = onenode.state .. str
																			end
											
											end --if
										end, -- function
						EndElement	= function (parser, name)
											if (name == "task") then
												if(issqueezetask) then table.insert(alltasks, onetask) end
												onetask = {taskid = 0, hour = "", minute = "", devices  = {}, enabled = true, days = {false, false, false, false, false, false, false}}
												squeezetag = ""
												enabledtag = ""
												issqueezetask = false
											elseif ((name == "byhour") or (name == "byminute") or (name == "byweekday") or (name == "start") or (name == "node") or (name == "until")) then
												--if (name == "byweekday") then log:info("End byweekday") end
												saxcallbacks.CharacterData = false
												 if (name == "node") then
													--table.insert(onetask.devices, onenode)
													onetask.devices[tostring(onenode.id)] = tonumber(onenode.state)
													onenode = {id = 0, state = ""}
													currentnode = 0
													
												end
											end
										end,
						CharacterData = false
						}
						
								
	local p = lxp.new(saxcallbacks)
	xml:settimeout(1)
	xml:connect(ip, 8081)
	xml:send(xmlreq)
	repeat
		local oneblock = xml:receive(10)
		if (oneblock != nil) then p:parse(oneblock) end
	until (oneblock == nil)
	p:parse()
	p:close()
	xml:close()
	--self:getSettings().TIMER = alltasks
	--self:storeSettings()
	return alltasks
	
end

function isInTimer(task, node)
	local ret = false
	for k, v in pairs(task.devices) do
		if (tonumber(node) == tonumber(k)) then ret = true end
	end
	return ret
end

function setTimerDevices(self, task)
	local window = Window("window", self:string("TIMER_DEVICE_MENU"))
	
	local menuitems = {}
 	local zwdevices = self:getSettings().zwDevices.names
 	local zwtypes = self:getSettings().zwDevices.types
 	
 	for k, v in pairs(zwdevices) do
 		local lable = ""
 		if (isInTimer(task, k)) then
 			if ((zwtypes[k] == "binary_switch") and (task.devices[k] == 1)) then
 				lable = string.format("%s (%s)", tostring(v), tostring(self:string("ON")))
 			elseif ((zwtypes[k] == "binary_switch") and (task.devices[k] == 2)) then
 				lable = string.format("%s (%s)", tostring(v), tostring(self:string("OFF")))
 			elseif ((zwtypes[k] == "multilevel_switch") and (task.devices[k] > 0)) then
 				lable = string.format("%s (%s%%)", tostring(v), tostring(task.devices[k]+1))
 			else
 				lable = string.format("%s (%s)", tostring(v), tostring(self:string("OFF")))
 			end
 		else
 			lable = v
 		end
 		table.insert(menuitems, {text = lable, icon = Checkbox("checkbox",
 															function(self1, isSelected)
 																if isSelected then
 																	local zwtype = zwtypes[k]
 																	local state = getState(self, k, zwtype)
 																	if (zwtype == "binary_switch") then
 																		task.devices[k] = state.onoff
 																	else
 																	if (state.onoff == 1) then
 																		task.devices[k] = tonumber(state.level)
 																	else
 																		task.devices[k] = 0
 																	end
 																end
 																else
 																	task.devices[k] = nil
 																	
 																end
 															end,
 															isInTimer(task, k)
 														)})
	end
	local menu = SimpleMenu("menu", menuitems)
	window:addWidget(menu)
	window:show()


end

function setTimerClock(self, task)
	local window = Window("window", self:string("TIME_OF_DAY"))

	local v = Textinput.timeValue(task.hour .. ":" .. task.minute)
	local input = Textinput("textinput", v,
				function(_, value)
					--log:info("Input " .. value:getValue())
					local time = value:getValue()
					local pos = string.find(time, ":")
					--log:info(": pos = ", pos)
					local hour = time:sub(1,pos-1)
					local minute = time:sub(pos+1, time:len())
					log:info("New time = ", hour, ":", minute)
					task.hour = hour
					task.minute = minute
					window:hide(Window.transitionPushRight)
					
				end)

	local help = Textarea("help", self:string("TIMER_CLOCK_HELP"))

	window:addWidget(help)
	window:addWidget(input)

	window:show()
end

function setDayOfWeek(self, task)
	local window = Window("window", self:string("DAY_OF_WEEK"))
									
	local items = {{
					text		= self:string("MONDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[1] = true
												else
													task.days[1] = false
												end
											end,
											task.days[1])
					},
					{
					text		= self:string("TUESDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[2] = true
												else
													task.days[2] = false
												end
											end,
											task.days[2])
					},
					{
					text		= self:string("WEDNESDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[3] = true
												else
													task.days[3] = false
												end
											end,
											task.days[3])
					},
					{
					text		= self:string("THURSDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[4] = true
												else
													task.days[4] = false
												end
											end,
											task.days[4])
					},
					{
					text		= self:string("FRIDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[5] = true
												else
													task.days[5] = false
												end
											end,
											task.days[5])
					},
					{
					text		= self:string("SATURDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[6] = true
												else
													task.days[6] = false
												end
											end,
											task.days[6])
					},
					{
					text		= self:string("SUNDAY"),
					icon		= Checkbox("checkbox", 
											function(self1, isSelected)
												if (isSelected) then
													task.days[7] = true
												else
													task.days[7] = false
												end
											end,
											task.days[7])
					},
			}
	local menu = SimpleMenu("menu", items)
	local help = Textarea("help", self:string("DAY_OF_WEEK_HELP"))
	window:addWidget(help)
	window:addWidget(menu)
	window:show()					
end

function yesNo(yes)
	if (yes) then
		return 1
	else
		return 2
	end
end

function enableTask(self, task, isenabled)
	task.enabled = isenabled
end

function editTimerEvent(self, wincap, task)
	local window = Window("window", wincap)
	local ip = self:getSettings().ihcIP
	
	local items = {
					{
					text		= self:string("TIMER_ENABLED"),
					icon		= Choice("choice",
										{self:string("YES"), self:string("NO")},
										function(self1, selectedIndex)
											if (selectedIndex == 1) then
												enableTask(self, task, true)
											else
												enableTask(self, task, false)
											end 
										end,
										yesNo(task.enabled)
										)
					},
					{
					text		= self:string("TIME_OF_DAY"),
					callback	= function(event, menuItem)
										setTimerClock(self, task)
									end
					},
					{
					text		= self:string("DAY_OF_WEEK"),
					callback	= function(event, menuItem)
										setDayOfWeek(self, task)
									end
					},
					{
					text		= self:string("CHOOSE_SCENE_DEVICES"),
					callback	= function(event, menuItem)
										setTimerDevices(self, task)
									end
					}
				}
	
	if (task.taskid  != 0) then
		table.insert(items, {
							text 		= self:string("UPDATE_TIMER"),
							icon		= Choice("choice",
											{" ", " "},
											function(self1, selectedItem)
												sendTaskToIHC(self, task, ip)
												window:hide(Window.transitionPushRight)
											end,
											1)
							})
		table.insert(items, {
							text		= self:string("DELETE_TIMER"),
							icon		= Choice("choice",
											{" ", " "},
											function (self1, selectedItem)
												log:info("Deleting task id = ", task.taskid)
												deleteTimerTask(self, task.taskid, ip)
												window:hide(Window.transitionPushRight)
											end,
											1)
							})
	else
		table.insert(items, {
							text 		= self:string("CREATE_TIMER"),
							icon		= Choice("choice",
											{" ", " "},
											function(self1, selectedItem)
												sendTaskToIHC(self, task, ip)
												window:hide(Window.transitionPushRight)
											end,
											1)
							})
	end
	
	
	local menu = SimpleMenu("menu", items)
	window:addWidget(menu)
	window:show()
end


function addNewTimerEvent(self)
	log:info("Add new timer...")
	local task = {taskid = 0, hour = "00", minute = "00", devices  = {}, enabled = true, days = {false, false, false, false, false, false, false}}
	editTimerEvent(self, self:string("ADD_NEW_TIMER"), task)
	
end



function timerSettings(self)
	local window = Window("window", self:string"TIMER_SETTINGS")
	local menu = SimpleMenu("menu", {})
	window:addListener(EVENT_HIDE, function(evt, menuItem)
									log:info("Removing menu from window")
									window:removeWidget(menu)
								end)
	window:addListener(EVENT_SHOW, function(evt, menuItem)
									log:info("Adding menu to window")
									local ip = self:getSettings().ihcIP
									local tasks = getTasksFromIHC(self, ip)
	
									local items = {{text	= self:string("ADD_NEW"), 
													callback= function(event, menuItem)
																addNewTimerEvent(self)
																end
													}}	
									local weekdaysshort = {self:string("MONDAY_SHORT"), self:string("TUESDAY_SHORT"), self:string("WEDNESDAY_SHORT"), self:string("THURSDAY_SHORT"), self:string("FRIDAY_SHORT"), self:string("SATURDAY_SHORT"), self:string("SUNDAY_SHORT"), }								 
									for k, v in ipairs(tasks) do
										local wdays = ""
										for kwd, vwd in ipairs(v.days) do
											if (vwd) then wdays = wdays .. tostring(weekdaysshort[kwd]) end
										end
										local menulable = string.format("%02d:%02d %s", tonumber(v.hour), tonumber(v.minute), wdays)
										if (not v.enabled) then menulable = string.format("(%s)", menulable) end
										table.insert(items, {text = menulable, callback = function (evt, menuItem)
																							log:info("Edit task id= ", v.taskid)
																							editTimerEvent(self, self:string("EDIT_TIMER"), v)
																						end
														})
									end
									menu = SimpleMenu("menu", items)
									window:addWidget(menu)
									end) --event
	window:show()
	

end

